(function ($, PHD, window, undefined) {
    const $form = $('#bds-form');
    let InternalDiskForm;
    const NAME_REGEX = /^[a-zA-Z0-9\-\_]+$/;
    const $d2d = $('#id_d2d_allocation');
    const $d2dGB = $('#id_d2d_gb');
    const $ir = $('#id_ir_allocation');
    const $irGB = $('#id_ir_gb');
    const $includedTable = $form.find('.included-disks');
    const $availableTable = $form.find('.available-disks');
    const $attached = $('#attached-disks');
    let DiskManager;
    const allocationSpinnerOptions = { min: 1, max: 99, step: 1 };
    const $storageID = $('#edit_object_id');
    const $systemID = $('#id_system');
    let paper = null;
    let system_id;
    let newtotal = 0;
    const isStateless = $('#stateless').val();
    const MINPERCENT = 0.00001;
    const Disks = function ($el) {
        this.$el = $el;
        this.$selected = null;
        this.$buttons = this.$el.find('.disk-controls a');
        this.uuid = '';
    };
    let hasDiskSizes = false;
    const scope = $('[ng-controller=GlobalCtrl]').scope();
    const isRecoverySeries = scope.isRecoverySeries;
    let load;
    let disks;

    Disks.prototype.gather = function () {
        this.$initial = $includedTable.find('tbody tr:not(.clickable)');
        this.$added = $includedTable.find('tbody tr.clickable');
        this.$included = this.$initial.add(this.$added);
        this.$available = $availableTable.find('tbody tr');
        if (this.$included.length) {
            this.uuid = this.$included.eq(0).data('uuid');
        }
        return this;
    };

    Disks.prototype.sumd2d = function (event, ui) {
        let adder = 0;
        if (ui !== undefined) {
            if (ui.value < $d2d.val()) {
                adder = +1;
            } else if (ui.value > $d2d.val()) {
                adder = -1;
            }
        }
        const ir = 100 - parseInt($d2d.val(), 10) + adder;
        $ir.val(ir);

        const ir_GB = Math.round((newtotal / 1024 * ir) / 100);
        const d2d_GB = Math.round(newtotal / 1024 - ir_GB);

        if (ir_GB == 0) {
            const d2dText = $d2dGB.text();
            let d2dTextOutput = d2dText.slice(1, d2dText.length - 1);
            d2dTextOutput = d2dTextOutput.split(' ');
            d2dTextOutput = parseInt(d2dTextOutput[0]);
            if (d2dTextOutput < d2d_GB) {
                const diff = d2d_GB - d2dTextOutput;
                $irGB.text(`(${diff} GB)`);
                $d2dGB.text(`(${d2dTextOutput} GB)`);
            }
        } else {
            $irGB.text(`(${ir_GB} GB)`);
            $d2dGB.text(`(${d2d_GB} GB)`);
        }
        this.sum();
    };

    Disks.prototype.sumir = function (event, ui) {
        let adder = 0;
        if (ui !== undefined) {
            if (ui.value < $ir.val()) {
                adder = +1;
            } else if (ui.value > $ir.val()) {
                adder = -1;
            }
        }
        const d2d = 100 - parseInt($ir.val(), 10) + adder;
        $d2d.val(d2d);

        const d2d_GB = Math.round((newtotal / 1024 * d2d) / 100);
        const ir_GB = Math.round(newtotal / 1024 - d2d_GB);

        if (ir_GB == 0) {
            const d2dText = $d2dGB.text();
            let d2dTextOutput = d2dText.slice(1, d2dText.length - 1);
            d2dTextOutput = d2dTextOutput.split(' ');
            d2dTextOutput = parseInt(d2dTextOutput[0]);
            if (d2dTextOutput < d2d_GB) {
                const diff = d2d_GB - d2dTextOutput;
                $irGB.text(`(${diff} GB)`);
                $d2dGB.text(`(${d2dTextOutput} GB)`);
            }
        } else {
            $irGB.text(`(${ir_GB} GB)`);
            $d2dGB.text(`(${d2d_GB} GB)`);
        }
        this.sum();
    };

    Disks.prototype.sum = function () {
        let d2d = parseInt($d2d.val(), 10) / 100;

        let ir = parseInt($ir.val(), 10) / 100;

        let total = this.$included
            .map(function () { return $(this).data('size'); })
            .get()
            .reduce((prev, next) => prev + next, 0);
        total = parseInt(total, 10);

        /*  For stateless storage, do not add the selected Storage */
        if (selectedStorage !== null) {
            if (!hasDiskSizes) {
                total += selectedStorage.mb_size;
            }
            newtotal = total;
        }

        // The disk count is 1 if not expandable, otherwise, get the number of included disks.
        const diskCount = (selectedStorage !== null && selectedStorage.is_expandable == false) ? 1 : this.$included.length;
        this.$diskUsage.text(getDiskUsageString(diskCount, PHD.util.formatMB(total)));

        if (d2d > ir) {
            ir = (ir > 0) ? ir : MINPERCENT;
            d2d = (d2d > 0) ? d2d : MINPERCENT;
            updatepieChart(paper, [d2d, ir], ['#5693d6', '#eae46e']);
        } else {
            ir = (ir > 0) ? ir : MINPERCENT;
            d2d = (d2d > 0) ? d2d : MINPERCENT;
            updatepieChart(paper, [d2d, ir], ['#eae46e', '#5693d6']);
        }

        return this;
    };

    Disks.prototype.selectRow = function (event) {
        let $row = $(event.target).closest('tr');

        if ($row.is('.current-row') || !$row.is('.clickable')) {
            return false;
        }
        if ($row.data('uuid') !== '') {
            $row = $row.closest('tbody').find(`tr[data-uuid='${$row.data('uuid')}']`);
        }
        this.$el.find('.current-row').removeClass('current-row');

        this.$selected = $row.addClass('current-row');
        return this.updateButtons();
    };

    Disks.prototype.addDisk = function () {
        this.$selected.detach().appendTo($includedTable);
        populateAttachedDiskFields();
        $form.validate().element($('#validate_disks'));
        return this.update();
    };

    Disks.prototype.removeDisk = function () {
        this.$selected.detach().appendTo($availableTable);
        populateAttachedDiskFields();
        return this.update();
    };

    Disks.prototype.resetDisks = function () {
        this.$el.find('tr.clickable').detach().appendTo($availableTable);
        populateAttachedDiskFields();
        return this.update();
    };

    Disks.prototype.refreshDisks = function () {
        const self = this;
        system_id = PHD.appliance_sid;
        const availableURL = `/api/storage/available-disks/?sid=${system_id}`;

        let resp;
        let respAvailable;
        let attached_names;
        let unattached_names;

        resp = PHD.Ajax.get(availableURL);

        resp.done((data) => {
            const info = selectedStorage;
            console.log(`storage  = ${JSON.stringify(info)}`);
            if (info != null && info.properties !== undefined) {
                // attached_names = _.pluck(info.attached_disks, "name");
                attached_names = info.properties;
                if (attached_names !== undefined) {
                    if (Array.isArray(attached_names)) {
                        attached_names.forEach((disk, index) => {
                            const obj = {};
                            obj.name = disk.name;
                            obj.rowType = 'static';
                            if (disk.mb_size !== undefined) {
                                obj.formatted_size = PHD.util.formatMB(disk.mb_size);
                                obj.mb_size = disk.mb_size;
                            } else {
                                obj.formatted_size = 'N/A';
                                obj.mb_size = 0;
                            }
                            obj.uuid = '---';
                            obj.partitioned = true;
                            obj.filesystem = true;
                            const html = rowTmpl(obj);
                            $(html).appendTo($includedTable);
                        });
                    } else {
                        // added internal.
                        const obj = {};
                        obj.name = attached_names.name;
                        obj.rowType = 'static';
                        // added internal is not expandable, disk size is the same as storage size.
                        obj.formatted_size = info.mb_size !== undefined ? PHD.util.formatMB(info.mb_size) : 'N/A';
                        obj.mb_size = 0;
                        obj.uuid = '---';
                        obj.partitioned = true;
                        obj.filesystem = true;
                        const html = rowTmpl(obj);
                        $(html).appendTo($includedTable);
                    }
                }
                // initialize attached
                populateAttachedDiskFields();
            }

            const available = data.attached_disks;
            if (available !== undefined) {
                unattached_names = _.pluck(available, 'name');
                available.forEach((value, index, arr) => {
                    const uid = value.name;
                    if (!$includedTable.find(`[data-name='${uid}']`).length
                        && !$availableTable.find(`[data-name='${uid}']`).length) {
                        console.log('new available disk', value.name);
                        value.rowType = 'clickable';
                        value.formatted_size = PHD.util.formatMB(value.mb_size);
                        const html = rowTmpl(value);
                        $(html).appendTo($availableTable);
                    }
                });
            }

            const names = _.union(attached_names, unattached_names);
            const $disks = self.$included.add(self.$available);
            $disks.each(function () {
                if (!_.contains(names, $(this).data('name'))) {
                    $(this).remove();
                }
            });

            self.update();
        });

        return this;
    };

    Disks.prototype.updateButtons = function () {
    // UNIBP-5884: Once the API supports > 1 disk addition, the last expression re: added disk length can be removed.
        if (this.$selected && $.contains($availableTable[0], this.$selected[0]) && (this.$added === undefined || this.$added.length == 0)) {
            this.$buttons.filter('.btn-add-disk')
                .removeClass('disabled')
                .on('click', $.proxy(this.addDisk, this));
        } else {
            this.$buttons.filter('.btn-add-disk').disableButton();
        }

        if (this.$selected && $.contains($includedTable[0], this.$selected[0])) {
            this.$buttons.filter('.btn-remove-disk')
                .removeClass('disabled')
                .on('click', $.proxy(this.removeDisk, this));
        } else {
            this.$buttons.filter('.btn-remove-disk').disableButton();
        }
        return this;
    };

    Disks.prototype.restrictDisks = function () {
    // TODO: handle what can be selected based on uuid/filesystem
    /* lmc - allow clickable if uuid set, because available-disks API will see if the disk is used elsewhere */
        this.$available.filter("[data-uuid!='']").removeClass('static').addClass('clickable');
        /* if(this.uuid) {
            this.$available.filter("[data-uuid!='']").removeClass("clickable").addClass("static");
        } else {
            this.$available.filter("[data-uuid!='']").removeClass("static").addClass("clickable");
        } */
        return this;
    };

    Disks.prototype.update = function () {
        initTables();
        // return this.gather().restrictDisks().sum().updateButtons();
        // lmc also update the allocation buttons if present.
        this.gather().restrictDisks().sum();
        this.sumd2d();
        this.sumir();
        return this.updateButtons();
    };

    Disks.prototype.init = function () {
        this.$diskUsage = $form.find('.disk-usage');

        $d2d.on('change spinchange spin', $.proxy(this.sumd2d, this));
        $ir.on('change spinchange spin', $.proxy(this.sumir, this));

        $includedTable.on('click', '.clickable', $.proxy(this.selectRow, this));
        $availableTable.on('click', '.clickable', $.proxy(this.selectRow, this));

        this.$buttons.filter('.btn-reset-disks').on('click', $.proxy(this.resetDisks, this));
        this.$buttons.filter('.btn-refresh-disks').on('click', $.proxy(this.refreshDisks, this));

        // lmc - add and move init function.
        this.refreshDisks(this);

        // See if the attached disk sizes are available on edit.
        if (selectedStorage !== null) {
            const storage = selectedStorage;
            disks = storage.properties;
            if (Array.isArray(disks)) {
                disks.forEach((disk, index) => {
                    if (disk.mb_size !== undefined) {
                        hasDiskSizes = true;
                    }
                });
            }
        }

        return this.update();
    };

    function initTables() {
        $includedTable.scrollTable({ height: 151, resize: false });
        $availableTable.scrollTable({ height: 151, resize: false });
    }

    function MaxNameValidation() {
        $.validator.addMethod('maxSizeNameValidation', (value, element) => {
            if (value.length < 10) {
                return true;
            }
            return false;
        }, 'Name can not exceed 9 characters');
    }

    function initForm() {
        $form.find('.definition').popover({
            appendTo: $form,
            position: {
                my: 'left bottom',
                at: 'right top-15'
            }
        });

        MaxNameValidation();

        // if adding, remove allocation pie, or used for backup copies.
        if (selectedStorage == null || (selectedStorage !== null && selectedStorage.usage == 'archive') || (selectedStorage !== null && selectedStorage.type !== 'internal')) {
            $('.bds-options').hide();
        }

        $d2d.spinner(allocationSpinnerOptions);
        $ir.spinner(allocationSpinnerOptions);

        // if adding, make sure a disk is attached.
        // if editing, and the storage is expandable, make sure a disk is attached.
        if (selectedStorage === null || (selectedStorage !== null && selectedStorage.is_expandable == true)) {
            $.validator.addMethod('validate-disks', (value, element) => $attached.find('[id=attached-disks]').length,
                gettext('Please add at least one disk.'));
        }

        if ((selectedStorage === null && isStateless) || (selectedStorage !== null && selectedStorage.mb_size === 0)) {
            $('#stateless_requirement_text').show();
        } else {
            $('#stateless_requirement_text').hide();
        }

        InternalDiskForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    name: {
                        required: true,
                        pattern: NAME_REGEX,
                        maxSizeNameValidation: true
                    },
                    d2d: {
                        required: true,
                        min: 1,
                        max: 100,
                        digits: true
                    },
                    ir: {
                        required: true,
                        min: 0,
                        max: 100,
                        digits: true
                    }
                },
                messages: {
                    name: {
                        required: 'The storage name is required'
                    },
                    d2d: {
                        required: gettext('Please enter a positive backups allocation'),
                        min: gettext('Please increase the space for backup allocation'),
                        max: gettext('Backups allocation may not exceed 100'),
                        digits: gettext('Backups allocation must be a number')
                    },
                    ir: {
                        required: gettext('Please enter a positive Instant Recovery allocation'),
                        min: gettext('Please enter a positive Instant Recovery allocation'),
                        max: gettext('Instant Recovery allocation may not exceed 100'),
                        digits: gettext('Instant Recovery allocation must be a number')
                    }
                }
            })
            .on('formcancel', (event) => {
                PHD.currentDialog.wizard('close');
            })
            .on('formsubmit', (event, data) => {
                $(document).trigger('bdssave', [system_id, data]);
                PHD.currentDialog.wizard('close');

                const scope = angular.element(document).scope();
                if (scope.user.showTour) {
                    if (scope.tourHostDisabled) {
                        scope.tourHostDisabled = false;
                    }
                    window.location.href = '#';
                }
            });

        InternalDiskForm.submit = function () {
            const self = this;

            load = PHD.showLoadingIndicator('body', true, 'Saving Storage...');
            const disks = {};

            this.$buttons.blur().disable();

            const submitData = form2js(this.$form.attr('id'), '.', false);

            const $editing_id = this.$form.find('#edit_object_id');
            console.log(`edit id text = ${$editing_id.text()} and appliance id is ${PHD.appliance_sid}`);
            const url_sid = (PHD.appliance_sid === null) ? '/' : `/?sid=${PHD.appliance_sid}`;
            let url = this.$form.attr('action');

            let storageObj = {};
            // if added disks, set "internal_name"
            // storageObj.internal_name = "";
            // get this after update so we know new size??
            const $added = $includedTable.find('tbody tr.clickable');
            const added_names = [];
            if ($added !== undefined) {
                $added.each(function (index) {
                    const name = $(this).find('[data-source="name"]').html();
                    console.log(`name to add is ${name}`);
                    added_names.push(name);
                });
                if (added_names.length > 0) {
                    disks.internal_name = added_names.toString();
                    storageObj.properties = disks;
                }
            }
            $('[ng-controller=GlobalCtrl]').scope().disks = disks;

            // get IR and d2d from GB label.
            const ir = parseInt($irGB.text().match(/\d+/), 10);
            const d2d = parseInt($d2dGB.text().match(/\d+/), 10);

            let isEdit = $editing_id.text() != 'none';
            let isStateless = false;

            if (selectedStorage != null) {
                if (selectedStorage.usage == 'stateless' && selectedStorage.stateless_type === null && added_names.length > 0) {
                    // Stateless storage has not been created.  We need to create it.
                    isStateless = true;
                    isEdit = false;
                    storageObj.name = '_Stateless';
                    storageObj.build_filesystem = 1; // create stateless storage
                    storageObj.usage = 'stateless';
                    storageObj.type = global.STORAGE_ADDED_INTERNAL;

                    // create stateless - turn off timers.
                    var scope = angular.element(document).scope();
                    scope.disableTimers();
                }
            }

            if (isEdit) {
                storageObj.type = selectedStorage.type == 'internal' ? global.STORAGE_ADDED_INTERNAL : mapStringToInt(selectedStorage.type);
                storageObj = JSON.stringify(storageObj);
                console.log(`Edit ${storageObj}`);
                if (added_names.length > 0) {
                    const storage_id = $editing_id.text();
                    url += storage_id + url_sid;
                    PHD.Ajax
                        .put(url, storageObj)
                        .done((data) => {
                            self.$form.trigger('formsubmit', [data, self.$form, self]);
                        })
                        .always(() => {
                            self.$buttons.enable();
                            updatePieValues(d2d, ir, url_sid);
                            PHD.hideLoadingIndicator(load);
                        });
                } else {
                    self.$buttons.enable();
                    if (selectedStorage.usage == 'stateless' || selectedStorage.usage == 'backup') {
                        // no disks added, just update pie
                        updatePieValues(d2d, ir, url_sid);
                    }
                    PHD.hideLoadingIndicator(load);
                    self.$form.trigger('formsubmit', [self.$form, self]);
                }
            } else {
                if (!isStateless) {
                    storageObj.name = submitData.name;
                    storageObj.usage = submitData.usage;
                    storageObj.type = submitData.type;
                }
                storageObj = JSON.stringify(storageObj);
                console.log(`Add ${storageObj}`);
                url += url_sid;
                var scope = angular.element(document).scope();
                const isXenUEB = scope.isXenUEB;
                PHD.Ajax
                    .post(url, storageObj, load, handleStorageError)
                    .done((data) => {
                        self.$form.trigger('formsubmit', [data, self.$form, self]);
                    })
                    .always(() => {
                        self.$buttons.enable();
                        PHD.hideLoadingIndicator(load);
                        if (isStateless) {
                            // create stateless - turn off timers.
                            const scope = angular.element(document).scope();
                            scope.enableTimers();
                        } else if (isXenUEB) {
                            const getIdURL = `/api/storage/id/${submitData.name}/?sid=${system_id}`;
                            const resp = PHD.Ajax.get(getIdURL);
                            let newstorageObj = {};

                            resp.done((data) => {
                                newstorageObj.max_concurrent_backups = 4;
                                newstorageObj = JSON.stringify(newstorageObj);
                                console.log(storageObj);
                                const url = `/api/storage/${data.id}${url_sid}`;
                                PHD.Ajax
                                    .put(url, newstorageObj)
                                    .done((data) => {
                                        self.$form.trigger('formsubmit', [data, self.$form, self]);
                                    })
                                    .always(() => {
                                        self.$buttons.enable();
                                        PHD.hideLoadingIndicator(load);
                                    });
                            });
                        }
                    });
            }

            return this;
        };
    }

    function handleStorageError(jqXHR, textStatus, errorThrown) {
        console.log('In handles toateg');
        PHD.hideLoadingIndicator(load);
        if (jqXHR.status === 500) {
            const data = jqXHR.responseJSON;
            const self = this;
            if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                const error = data.result[0].message;
                console.log(`The error is:${error}`);

                if (error.indexOf('Storage configuration failed - this volume contains existing data, are you sure you want to format it?') > -1) { // Check if storage contains existing data, so we can show user option to recover.
                    let storageObj = {};
                    let disks = $('[ng-controller=GlobalCtrl]').scope().disks;
                    const url = `${'/api/storage/' + '?sid='}${PHD.appliance_sid}`;
                    $('#dialog-message').dialog({
                        modal: true,
                        buttons: {
                            Recover() {
                                storageObj.name = '_Stateless';
                                storageObj.build_filesystem = 0; // create stateless storage
                                storageObj.usage = 'stateless';
                                storageObj.type = global.STORAGE_ADDED_INTERNAL;
                                storageObj.properties = disks;
                                storageObj = JSON.stringify(storageObj);
                                load = PHD.showLoadingIndicator('body', true, 'Recovering Storage...');
                                PHD.Ajax
                                    .post(url, storageObj, load, handleStorageError)
                                    .done((data) => {
                                        PHD.hideLoadingIndicator(load);
                                        // create stateless - turn off timers.
                                        const scope = angular.element(document).scope();
                                        scope.enableTimers();
                                    });
                                $(this).dialog('close');
                            },
                            'Erase Data': function () {
                                storageObj.name = '_Stateless';
                                storageObj.build_filesystem = 2; // create stateless storage
                                storageObj.usage = 'stateless';
                                storageObj.type = global.STORAGE_ADDED_INTERNAL;
                                storageObj.properties = disks;
                                storageObj = JSON.stringify(storageObj);
                                load = PHD.showLoadingIndicator('body', true, 'Erasing Storage...');
                                PHD.Ajax
                                    .post(url, storageObj, load, handleStorageError)
                                    .done((data) => {
                                        PHD.hideLoadingIndicator(load);
                                        // create stateless - turn off timers.
                                        const scope = angular.element(document).scope();
                                        scope.enableTimers();
                                    });
                                $(this).dialog('close');
                            },
                            Cancel() {
                                $(this).dialog('close');
                            }

                        }
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.throwError(data);
            }
        } else {
            PHD.ajaxError(jqXHR, textStatus, errorThrown);
        }
    }

    function updatePieValues(d2d, ir, url_sid) {
        let obj = {};
        obj.allowed = ir;
        obj = JSON.stringify(obj);
        // now set ir and d2d (if not virtual).
        PHD.Ajax
            .put(`/api/storage/ir${url_sid}`, obj)
            .done((data) => {
                if (isRecoverySeries) {
                    console.log('is recovery series, set d2d');
                    obj = {};
                    obj.allowed = d2d;
                    obj = JSON.stringify(obj);
                    PHD.Ajax
                        .put('/api/storage/d2d', obj)
                        .done((data) => {

                        });
                }
            });
    }

    function initPieChart() {
        let d2d = parseInt($d2d.val(), 10) / 100;

        let ir = parseInt($ir.val(), 10) / 100;

        const $pie = $('#allocation-pie');
        // no pie for IR, or for anything but internal storage.
        if ($pie.html() !== undefined) {
            paper = createpieChart('allocation-pie');
            if (d2d > ir) {
                ir = (ir > 0) ? ir : MINPERCENT;
                d2d = (d2d > 0) ? d2d : MINPERCENT;
                updatepieChart(paper, [d2d, ir], ['#5693d6', '#eae46e']);
            } else {
                ir = (ir > 0) ? ir : MINPERCENT;
                d2d = (d2d > 0) ? d2d : MINPERCENT;
                updatepieChart(paper, [d2d, ir], ['#eae46e', '#5693d6']);
            }
        }
    }

    function populateAttachedDiskFields() {
        $attached.html(
            $includedTable.find('tbody tr td[data-source=name]').map(function () {
                return `<input type="hidden" id="attached-disks" name="properties.attached_disks" value="${$(this).text()}">`;
            }).get().join(''),
        );
    }

    function getDiskUsageString(numDisks, totalDiskSize) {
        const fmt = ngettext('Using %(num_disks)s attached disk (%(total_disk_size)s)', 'Using %(num_disks)s attached disks (%(total_disk_size)s)', numDisks);
        return interpolate(fmt, { num_disks: numDisks, total_disk_size: totalDiskSize }, true);
    }

    /*
    *   DOM Ready Function
    */
    $(() => {
        DiskManager = new Disks($form.find('.bds-disks')).init();

        PHD.currentDialog.one('wizardfocus', () => {
            initForm();
            initTables();
            initPieChart();
        });

        // set disk manager read-only if not expandable
        if (selectedStorage && selectedStorage.is_expandable === false) {
            console.log('Selected storage is NOT expandable');
            $('.included-disks').disable();
            $('.disk-controls').hide();
            $('.available-disks').hide();
            $('#not-expandable').show();
        }
    });

    var rowTmpl = _.template(
        '<tr class="<%= rowType %>" data-dbid="<%= name %>" data-uuid="<%= uuid %>" data-size="<%= mb_size %>">'
            + '<td data-source="name"><%= name %></td>'
            + '<td><%= uuid %></td>'
            + '<td><%= partitioned %></td>'
            + '<td><%= filesystem %></td>'
            + '<td><%= formatted_size %></td>'
        + '</tr>',
    );

    function createpieChart(holderId) {
        const r = Raphael(holderId);
        return r;
    }

    function updatepieChart(r, dataPointsArray, colorsArray) {
        if (r != null) {
            r.clear();
            if (colorsArray !== undefined) {
                var pie = r.piechart(160, 100, 90, dataPointsArray, { minPercent: MINPERCENT, colors: colorsArray });
            } else {
                var pie = r.piechart(160, 100, 90, dataPointsArray, { minPercent: MINPERCENT });
            }
        }
    }

    function mapStringToInt(strtype) {
        let type;
        if (strtype == 'internal') {
            type = global.STORAGE_INTERNAL;
        } else if (strtype == 'iscsi') {
            type = global.STORAGE_ISCSI;
        } else if (strtype == 'nas') {
            type = global.STORAGE_NAS;
        } else if (strtype == 'added_internal') {
            type = global.STORAGE_ADDED_INTERNAL;
        } else if (type == 'fc') {
            type = global.STORAGE_FC;
        }
        return type;
    }
}(jQuery, window.PHD || (window.PHD = {}), window));
