import { gettext } from '../utils';
/*
 * These constants are both exported for use in new React code
 * as well as placed on the global scope to support the legacy angular code where needed
 */

export const JOB_TYPE_UNKNOWN = 0;
global.JOB_TYPE_UNKNOWN = JOB_TYPE_UNKNOWN;
export const JOB_TYPE_BACKUP = 1;
global.JOB_TYPE_BACKUP = JOB_TYPE_BACKUP;
export const JOB_TYPE_RESTORE = 2;
global.JOB_TYPE_RESTORE = JOB_TYPE_RESTORE;
export const JOB_TYPE_ROLLBACK = 3;
global.JOB_TYPE_ROLLBACK = JOB_TYPE_ROLLBACK;
export const JOB_TYPE_REPLICATION = 4;
global.JOB_TYPE_REPLICATION = JOB_TYPE_REPLICATION;
export const JOB_TYPE_NCDP = 5;
global.JOB_TYPE_NCDP = JOB_TYPE_NCDP;
export const JOB_TYPE_INSTANT_RESTORE = 6;
global.JOB_TYPE_INSTANT_RESTORE = JOB_TYPE_INSTANT_RESTORE;
export const JOB_TYPE_LINK = 7;
global.JOB_TYPE_LINK = JOB_TYPE_LINK;
export const JOB_TYPE_DELETE = 8;
global.JOB_TYPE_DELETE = JOB_TYPE_DELETE;
export const JOB_TYPE_BDSIO = 9;
global.JOB_TYPE_BDSIO = JOB_TYPE_BDSIO;
export const JOB_TYPE_VERIFY = 10;
global.JOB_TYPE_VERIFY = JOB_TYPE_VERIFY;
export const JOB_TYPE_ORPHAN_HUNT = 11;
global.JOB_TYPE_ORPHAN_HUNT = JOB_TYPE_ORPHAN_HUNT;
export const JOB_TYPE_SNAPSHOT_HUNT = 12;
global.JOB_TYPE_SNAPSHOT_HUNT = JOB_TYPE_SNAPSHOT_HUNT;
export const JOB_TYPE_HYPERVISOR = 13;
global.JOB_TYPE_HYPERVISOR = JOB_TYPE_HYPERVISOR;
export const JOB_TYPE_BACKUP_DISK = 14;
global.JOB_TYPE_BACKUP_DISK = JOB_TYPE_BACKUP_DISK;
export const JOB_TYPE_ARCHIVE = 16;
global.JOB_TYPE_ARCHIVE = JOB_TYPE_ARCHIVE;
export const JOB_TYPE_IR_START = 18;
global.JOB_TYPE_IR_START = JOB_TYPE_IR_START;
export const JOB_TYPE_IR_SEED = 19;
global.JOB_TYPE_IR_SEED = JOB_TYPE_IR_SEED;
export const JOB_TYPE_IR_MOTION = 20;
global.JOB_TYPE_IR_MOTION = JOB_TYPE_IR_MOTION;
export const JOB_TYPE_IR_END = 21;
global.JOB_TYPE_IR_END = JOB_TYPE_IR_END;
export const JOB_TYPE_CERTIFICATION = 22;
global.JOB_TYPE_CERTIFICATION = JOB_TYPE_CERTIFICATION;
export const JOB_TYPE_ARCHIVE_DISK = 17;
global.JOB_TYPE_ARCHIVE_DISK = JOB_TYPE_ARCHIVE_DISK;
export const JOB_TYPE_RESTORE_DISK = 15;
global.JOB_TYPE_RESTORE_DISK = JOB_TYPE_RESTORE_DISK;
export const RECOVERY_JOB_TYPE_STANDARD = 1;
global.RECOVERY_JOB_TYPE_STANDARD = RECOVERY_JOB_TYPE_STANDARD;
export const RECOVERY_JOB_TYPE_ROLLBACK = 0;
global.RECOVERY_JOB_TYPE_ROLLBACK = RECOVERY_JOB_TYPE_ROLLBACK;
export const RECOVERY_JOB_TYPE_INSTANT = 2;
global.RECOVERY_JOB_TYPE_INSTANT = RECOVERY_JOB_TYPE_INSTANT;
export const MAX_PASSWORD_LENGTH = 64;
export const HYPERVISOR_NA = 0;
export const HYPERVISOR_XEN = 1;
export const HYPERVISOR_VMWARE = 3;
export const HYPERVISOR_HYPERV = 4;
export const HYPERVISOR_VMWARE_STANDALONE_HOST = 5;
export const HYPERVISOR_AHV = 6;
export const DEFAULT_XEN_VIEW = 6;
global.DEFAULT_XEN_VIEW = DEFAULT_XEN_VIEW;
export const DEFAULT_VMWARE_VIEW = 3;
global.DEFAULT_VMWARE_VIEW = DEFAULT_VMWARE_VIEW;
export const DEFAULT_HYPERV_VIEW = 10;
global.DEFAULT_HYPERV_VIEW = DEFAULT_HYPERV_VIEW;
export const ALERT_TYPE_UNKNOWN = 0;
global.ALERT_TYPE_UNKNOWN = ALERT_TYPE_UNKNOWN;
export const ALERT_TYPE_OTHER = 1;
global.ALERT_TYPE_OTHER = ALERT_TYPE_OTHER;
export const ALERT_TYPE_LICENSE_EXPIRED = 2;
global.ALERT_TYPE_LICENSE_EXPIRED = ALERT_TYPE_LICENSE_EXPIRED;
export const ALERT_TYPE_LICENSE_INVALID = 3;
global.ALERT_TYPE_LICENSE_INVALID = ALERT_TYPE_LICENSE_INVALID;
export const ALERT_TYPE_UPDATES_AVAILABLE = 4;
global.ALERT_TYPE_UPDATES_AVAILABLE = ALERT_TYPE_UPDATES_AVAILABLE;
export const ALERT_TYPE_BDS_CREATE = 5;
global.ALERT_TYPE_BDS_CREATE = ALERT_TYPE_BDS_CREATE;
export const ALERT_TYPE_BDS_CONNECTIVITY = 6;
global.ALERT_TYPE_BDS_CONNECTIVITY = ALERT_TYPE_BDS_CONNECTIVITY;
export const ALERT_TYPE_BDS_LOW_SPACE = 7;
global.ALERT_TYPE_BDS_LOW_SPACE = ALERT_TYPE_BDS_LOW_SPACE;
export const ALERT_TYPE_VBA_CONNECTIVITY = 8;
global.ALERT_TYPE_VBA_CONNECTIVITY = ALERT_TYPE_VBA_CONNECTIVITY;
export const ALERT_TYPE_BACKUP_WINDOW = 9;
global.ALERT_TYPE_BACKUP_WINDOW = ALERT_TYPE_BACKUP_WINDOW;
export const ALERT_TYPE_BACKUP_NO_CBT = 10;
global.ALERT_TYPE_BACKUP_NO_CBT = ALERT_TYPE_BACKUP_NO_CBT;
export const ALERT_TYPE_BACKUP_FULL = 11;
global.ALERT_TYPE_BACKUP_FULL = ALERT_TYPE_BACKUP_FULL;
export const ALERT_TYPE_HYPERVISOR_SNAPSHOT = 12;
global.ALERT_TYPE_HYPERVISOR_SNAPSHOT = ALERT_TYPE_HYPERVISOR_SNAPSHOT;
export const ALERT_TYPE_HYPERVISOR_LOGIN = 13;
global.ALERT_TYPE_HYPERVISOR_LOGIN = ALERT_TYPE_HYPERVISOR_LOGIN;
export const ALERT_TYPE_UNPROTECTED_VM = 14;
global.ALERT_TYPE_UNPROTECTED_VM = ALERT_TYPE_UNPROTECTED_VM;
export const ALERT_TYPE_FLR = 15;
global.ALERT_TYPE_FLR = ALERT_TYPE_FLR;
export const ALERT_TYPE_INVENTORY_SYNC = 16;
global.ALERT_TYPE_INVENTORY_SYNC = ALERT_TYPE_INVENTORY_SYNC;
export const ALERT_TYPE_UPDATE_COMPLETE = 17;
global.ALERT_TYPE_UPDATE_COMPLETE = ALERT_TYPE_UPDATE_COMPLETE;
export const ALERT_TYPE_IR = 18;
global.ALERT_TYPE_IR = ALERT_TYPE_IR;
export const ALERT_TYPE_LINK = 19;
global.ALERT_TYPE_LINK = ALERT_TYPE_LINK;
export const ALERT_TYPE_EMAIL_ERROR = 101;
global.ALERT_TYPE_EMAIL_ERROR = ALERT_TYPE_EMAIL_ERROR;
export const ALERT_TYPE_SMTP_NOT_CONFIGURED = 102;
global.ALERT_TYPE_SMTP_NOT_CONFIGURED = ALERT_TYPE_SMTP_NOT_CONFIGURED;

// lmc - backup "types"
export const BACKUP_MODE_VIRTUAL_FULL = 1;
global.BACKUP_MODE_VIRTUAL_FULL = BACKUP_MODE_VIRTUAL_FULL;
export const BACKUP_MODE_FULL_AND_INC = 2;
global.BACKUP_MODE_FULL_AND_INC = BACKUP_MODE_FULL_AND_INC;
export const BACKUP_MODE_FULL_AND_INC_FULL = 3;

// lmc - retention settings
export const ARCHIVE_RETENTION_TYPICAL = 1;
export const ARCHIVE_RETENTION_KEEP_ALL = 2;
export const ARCHIVE_RETENTION_CUSTOM = 3;

// lmc - storage status
export const CONN_STATUS_UNKNOWN = 0;
global.CONN_STATUS_UNKNOWN = CONN_STATUS_UNKNOWN;
export const CONN_STATUS_OFF = 1;
global.CONN_STATUS_OFF = CONN_STATUS_OFF;
export const CONN_STATUS_CANNOT_CONNECT = -1;
global.CONN_STATUS_CANNOT_CONNECT = CONN_STATUS_CANNOT_CONNECT;
export const CONN_STATUS_ON = 2;
global.CONN_STATUS_ON = CONN_STATUS_ON;

// lmc - storage usage
export const BDS_TYPE_BACKUP = 1;
global.BDS_TYPE_BACKUP = BDS_TYPE_BACKUP;
export const BDS_TYPE_REPLICATION = 2;
global.BDS_TYPE_REPLICATION = BDS_TYPE_REPLICATION;
export const BDS_TYPE_CLOUD_CACHE = 4;
global.BDS_TYPE_CLOUD_CACHE = BDS_TYPE_CLOUD_CACHE;
export const BDS_TYPE_IR_CACHE = 8;
global.BDS_TYPE_IR_CACHE = BDS_TYPE_IR_CACHE;
export const BDS_TYPE_ARCHIVE = 16;
global.BDS_TYPE_ARCHIVE = BDS_TYPE_ARCHIVE;
export const BDS_TYPE_SYNC = 32;
global.BDS_TYPE_SYNC = BDS_TYPE_SYNC;

// Storage types
export const STORAGE_INTERNAL = 0;
global.STORAGE_INTERNAL = STORAGE_INTERNAL;
export const STORAGE_ISCSI = 1;
global.STORAGE_ISCSI = STORAGE_ISCSI;
export const STORAGE_FC = 2;
global.STORAGE_FC = STORAGE_FC;
export const STORAGE_NAS = 4;
global.STORAGE_NAS = STORAGE_NAS;
export const STORAGE_ADDED_INTERNAL = 5;
global.STORAGE_ADDED_INTERNAL = STORAGE_ADDED_INTERNAL;

// lmc - RESTlike calls to the server
export const AJAX_ID_GLOBAL = 0;
export const AJAX_ID_NON_EXISTENT = -1;

export const FALSE = 0;
global.FALSE = FALSE;
export const TRUE = 1;
global.TRUE = TRUE;

// lmc - log level definitions
export const LOG_LEVEL_EMERGENCY = 0;
global.LOG_LEVEL_EMERGENCY = LOG_LEVEL_EMERGENCY;
export const LOG_LEVEL_ALERT = 1;
global.LOG_LEVEL_ALERT = LOG_LEVEL_ALERT;
export const LOG_LEVEL_CRITICAL = 2;
global.LOG_LEVEL_CRITICAL = LOG_LEVEL_CRITICAL;
export const LOG_LEVEL_ERROR = 3;
global.LOG_LEVEL_ERROR = LOG_LEVEL_ERROR;
export const LOG_LEVEL_WARNING = 4;
global.LOG_LEVEL_WARNING = LOG_LEVEL_WARNING;
export const LOG_LEVEL_NOTICE = 5;
global.LOG_LEVEL_NOTICE = LOG_LEVEL_NOTICE;
export const LOG_LEVEL_INFO = 6;
global.LOG_LEVEL_INFO = LOG_LEVEL_INFO;

// lmc - removed unused INV_TYPE constants
export const INV_TYPE_UNIVERSE = 8;
global.INV_TYPE_UNIVERSE = INV_TYPE_UNIVERSE;

// lmc - REST API return codes
export const AJAX_RESULT_SUCCESS = 0;
export const AJAX_RESULT_PARTIAL_SUCCESS = 3;
export const AJAX_RESULT_WARNING = 1;
export const AJAX_RESULT_UNAUTHENTICATED = -1;
global.AJAX_RESULT_UNAUTHENTICATED = AJAX_RESULT_UNAUTHENTICATED;
export const AJAX_RESULT_ERROR = 2;

// lmc - verify types
export const VERIFY_TYPE_NONE = 1;
export const VERIFY_TYPE_QUICK = 2;
export const VERIFY_TYPE_FULL = 3;

// lmc - presentation layer - job manager tab IDs
export const JOB_TAB_ACTIVE = 0;
export const JOB_TAB_MANAGER = 1;
export const JOB_TAB_HISTORY = 2;
global.JOB_TAB_HISTORY = JOB_TAB_HISTORY;
export const JOB_TAB_SYSTEM = 3;
export const JOB_TAB_POLICIES = 4;
export const JOB_TAB_CALENDAR = 5;

// lmc - instant recovery state
export const INSTANT_VM_STATE_UNKNOWN = 0;
global.INSTANT_VM_STATE_UNKNOWN = INSTANT_VM_STATE_UNKNOWN;
export const INSTANT_VM_STATE_CREATING = 1;
global.INSTANT_VM_STATE_CREATING = INSTANT_VM_STATE_CREATING;
export const INSTANT_VM_STATE_ACTIVE = 2;
global.INSTANT_VM_STATE_ACTIVE = INSTANT_VM_STATE_ACTIVE;
export const INSTANT_VM_STATE_SEEDING = 3;
global.INSTANT_VM_STATE_SEEDING = INSTANT_VM_STATE_SEEDING;
export const INSTANT_VM_STATE_READY = 4;
global.INSTANT_VM_STATE_READY = INSTANT_VM_STATE_READY;
export const INSTANT_VM_STATE_COMPLETING = 5;
global.INSTANT_VM_STATE_COMPLETING = INSTANT_VM_STATE_COMPLETING;
export const INSTANT_VM_STATE_COMPLETED = 6;
global.INSTANT_VM_STATE_COMPLETED = INSTANT_VM_STATE_COMPLETED;
export const INSTANT_VM_STATE_ENDING = 7;
global.INSTANT_VM_STATE_ENDING = INSTANT_VM_STATE_ENDING;
export const INSTANT_VM_STATE_ENDED = 8;
global.INSTANT_VM_STATE_ENDED = INSTANT_VM_STATE_ENDED;
export const INSTANT_VM_STATE_ERROR = 9;
global.INSTANT_VM_STATE_ERROR = INSTANT_VM_STATE_ERROR;

export const SAVE_STATE_PRESENTATION = 0;
export const SAVE_STATE_MANAGEMENT = 1;
export const SAVE_STATE_ENGINE = 2;
export const SAVE_STATE_FINISHED = 3;

export const SAVE_STATUS_ERRORS = 3;
export const SAVE_STATUS_PENDING = 0;
export const SAVE_STATUS_SAVED = 1;
export const SAVE_STATUS_DELETED = 4;
export const SAVE_STATUS_SAVED_ERRORS = 2;

export const EMAIL_ENCRYPTION_NONE = 0;
export const EMAIL_ENCRYPTION_TLS = 1;
export const EMAIL_ENCRYPTION_SSL = 2;

// lmc - presentation layer  - dashboard refresh in ms
export const DEFAULT_JOBS_REFRESH = 5000;
export const DEFAULT_STORAGE_REFRESH = 5000;
export const DEFAULT_ALERT_REFRESH = 5000;
export const DEFAULT_RESTORE_REFRESH = 5000;
export const DEFAULT_ACTIVE_JOB_REFRESH = 5000;
export const DEFAULT_REPLICATION_REFRESH = 5000;
export const DEFAULT_BACKUP_REFRESH = 5000;

// lmc - presentation layer - widget identifiers
export const BACKUP_REFRESH = 0;
export const REPLICATION_REFRESH = 1;
export const RESTORE_REFRESH = 2;
export const ALERT_REFRESH = 3;
export const ACTIVE_JOB_REFRESH = 4;
export const STORAGE_REFRESH = 5;
export const JOBS_REFRESH = 6;

export const UPDATE_STATUS_UNKNOWN = 0;
export const UPDATE_STATUS_AVAILABLE = 1;
export const UPDATE_STATUS_PENDING = 2;
export const UPDATE_STATUS_UPDATING = 3;
export const UPDATE_STATUS_COMPLETED = 4;
export const UPDATE_STATUS_FAILED = 5;

export const FLR_TYPE_CIFS = 0;
export const FLR_TYPE_ISCSI = 1;

export const MODE_SUBTYPE_FULL = 0;
export const MODE_SUBTYPE_INC = 1;

export const BACKUP_CATALOG_RECOVERY_DIALOG = 2;
export const BACKUP_CATALOG_ROLLBACK_DIALOG = 3;
export const BACKUP_CATALOG_TAB = 0;
export const BACKUP_CATALOG_VIEW_DATE = 1;
global.BACKUP_CATALOG_VIEW_DATE = BACKUP_CATALOG_VIEW_DATE;
export const BACKUP_CATALOG_FLR_DIALOG = 1;
export const BACKUP_CATALOG_VIEW_BDS = 3;
global.BACKUP_CATALOG_VIEW_BDS = BACKUP_CATALOG_VIEW_BDS;
export const BACKUP_CATALOG_VIEW_APPLIANCE = 4;
global.BACKUP_CATALOG_VIEW_APPLIANCE = BACKUP_CATALOG_VIEW_APPLIANCE;

export const BACKUP_CATALOG_VIEW_VM = 0;
global.BACKUP_CATALOG_VIEW_VM = BACKUP_CATALOG_VIEW_VM;
export const BACKUP_CATALOG_VIEW_ROLLBACK = 2;
global.BACKUP_CATALOG_VIEW_ROLLBACK = BACKUP_CATALOG_VIEW_ROLLBACK;

export const BACKUP_STATUS_SUCCESS = 0;
export const BACKUP_STATUS_WARNING = 1;
export const BACKUP_STATUS_FAILURE = 2;

export const CREDENTIAL_TYPE_NONE = 0;
export const CREDENTIAL_TYPE_FILE_REC_CREDS = 1;
export const CREDENTIAL_TYPE_FROM_CONFIG = 2;
export const CREDENTIAL_TYPE_SYS_GEN = 3;
export const CREDENTIAL_TYPE_CUSTOM = 4;

export const LICENSING_UNLIMITED_SOCKETS = -1;

export const SYNC_STATUS_PENDING = 0;
export const SYNC_STATUS_ACTIVE = 1;
export const SYNC_STATUS_ERROR = 2;

export const SCHEDULE_RUN_EVERY = 0;
export const SCHEDULE_RUN_FIRST = 1;
export const SCHEDULE_RUN_SECOND = 2;
export const SCHEDULE_RUN_THIRD = 3;

// PROTECT_SETTINGS=1;

export const SCHEDULE_TYPE_SCHEDULED = 4;
global.SCHEDULE_TYPE_SCHEDULED = SCHEDULE_TYPE_SCHEDULED;
export const SCHEDULE_TYPE_NOW = 1;
global.SCHEDULE_TYPE_NOW = SCHEDULE_TYPE_NOW;
// SCHEDULE_TYPE_RUN_ONCE=2;
// SCHEDULE_TYPE_ON_DEMAND=3;

export const VERSION_UP_TO_DATE = 0;
global.VERSION_UP_TO_DATE = VERSION_UP_TO_DATE;
export const VERSION_UPDATE_IN_PROGRESS = 2;
global.VERSION_UPDATE_IN_PROGRESS = VERSION_UPDATE_IN_PROGRESS;
export const VERSION_NOT_UP_TO_DATE = 1;
global.VERSION_NOT_UP_TO_DATE = VERSION_NOT_UP_TO_DATE;

export const LOCATION_OR_TARGET_TARGET = 2;
export const LOCATION_OR_TARGET_LOCATION = 1;

export const INCLUDE_NEW_HW_NONE = 0;
export const INCLUDE_NEW_HW_ALL = 1;
export const INCLUDE_NEW_HW_DISKS_ONLY = 2;
export const INCLUDE_NEW_HW_VM_SETTINGS_ONLY = 3;

// lmc - quiesce VM on backup
export const QUIESCE_YES = 1;
export const QUIESCE_NO = 0;

export const RETENTION_KEEP_ALL = 2;
export const RETENTION_TYPICAL = 1;

export const PRIORITY_LOW = 0;
export const PRIORITY_MEDIUM = 50;
export const PRIORITY_HIGH = 100;

// lmc - presentation - report type to generate
export const REPORT_TYPE_HTML = 1;
export const REPORT_TYPE_CSV = 2;
export const REPORT_TYPE_PDF = 3;

// lmc - presentation - tour/quickstart only
export const ENABLE_TOUR = 7;

export const PROTECT_STATUS = 0;

export const ERR_INVENTORY = 'Select at least one inventory item.';
global.ERR_INVENTORY = ERR_INVENTORY;
// LOGIN_URL = "/api/login/";

export const NETWORK_TYPE_DHCP = 'dhcp';
export const NETWORK_TYPE_STATIC = 'static';

export const BLANK_LISTBOX_TEXT = '\u002D\u002D\u002D\u002D\u002D\u002D\u002D\u002D\u002D';

// ERR_INVALID_UPDATE_FILENAME = "Invalid filename. The filename should be in this format: phdvb\u002D7.0.1.9083.phd";
export const ERR_WEEKLY_RUN_DAY = 'Select at least one day for the job to run.';
global.ERR_WEEKLY_RUN_DAY = ERR_WEEKLY_RUN_DAY;
export const ERR_START_DATE_GT_END_DATE = 'The \u0027From\u0027 date cannot be after the \u0027To\u0027 date';
global.ERR_START_DATE_GT_END_DATE = ERR_START_DATE_GT_END_DATE;
export const KNOWLEDGE_BASE_URL = 'https://unitrends-support.force.com/UnitrendsBackup/s/';
global.KNOWLEDGE_BASE_URL = KNOWLEDGE_BASE_URL;
export const CE_KNOWLEDGE_BASE_URL = 'https://unitrends-support.force.com/UnitrendsFree/s/';
export const DOCUMENTATION_URL = 'https://unitrends-support.force.com/UnitrendsBackup/s/';
global.DOCUMENTATION_URL = DOCUMENTATION_URL;
export const CE_DOCUMENTATION_URL = 'http://www.unitrends.com/docs/user-guides/unitrends-free-administrators-guide';
global.CE_DOCUMENTATION_URL = CE_DOCUMENTATION_URL;
export const CE_BROWSER_URL = 'https://unitrends-support.force.com/UnitrendsFree/s/article/000003589';
global.CE_BROWSER_URL = CE_BROWSER_URL;
export const RELEASE_NOTES_URL = 'http://www.unitrends.com/special-pages/categories?categoryid=79';

export const DEFAULT_START_TIME = '20:00:00';
export const DEFAULT_END_TIME = '04:00:00';
export const DEFAULT_DO_NOT_RUN_AFTER_TIME = '23:59:00';
export const DEFAULT_EMAIL_PORT = '25';
export const DEFAULT_TIMEZONE = 'US/Eastern';

export const EMPTY_CELL_TEXT = '\u002D\u002D';
global.EMPTY_CELL_TEXT = EMPTY_CELL_TEXT;
export const RETENTION_VIRTUAL_FILL_SINGULAR = 'Assuming one year of daily backups, these settings will keep %s Virtual Full backup per VM.';
export const RETENTION_FULL_INC = 'Assuming Fulls are scheduled weekly, these settings will keep %s Full and %s Incremental backups.';
export const RETENTION_VIRTUAL_FILL_PLURAL = 'Assuming one year of daily backups, these settings will keep %s Virtual Full backups per VM.';

// STATIC_URL = "/static/";
// lmc
export const STATIC_URL = 'assets/';

// Application IDs.
export const APP_ID_FILE_LEVEL = 1;
export const APP_ID_EXCHANGE_2003 = 2;
export const APP_ID_EXCHANGE_2007 = 3;
export const APP_ID_EXCHANGE_2010 = 4;
export const APP_ID_EXCHANGE_2013 = 5;
export const APP_ID_EXCHANGE_2016 = 6;
export const APP_ID_SQL_SERVER_2005 = 21;
export const APP_ID_SQL_SERVER_2008 = 22;
export const APP_ID_SQL_SERVER_2008_R2 = 23;
export const APP_ID_SQL_SERVER_2012 = 24;
export const APP_ID_SQL_SERVER_2014 = 25;
export const APP_ID_SQL_SERVER_2016 = 26;
export const APP_ID_SQL_SERVER_2017 = 27;
export const APP_ID_ARCHIVE = 30;
export const APP_ID_VMWARE = 40;
export const APP_ID_HYPERV_2008_R2 = 50;
export const APP_ID_HYPERV_2012 = 51;
export const APP_ID_HYPERV_2016 = 52;
export const APP_ID_ORACLE_11 = 100;
export const APP_ID_ORACLE_12 = 101;
export const APP_ID_ORACLE_10 = 102;
export const APP_ID_SHAREPOINT_2007 = 110;
export const APP_ID_SHAREPOINT_2010 = 111;
export const APP_ID_SHAREPOINT_2013 = 112;
export const APP_ID_SHAREPOINT_2016 = 113;
export const APP_ID_CISCO_UCS_SERVICE_PROFILE = 120;
export const APP_ID_NDMP = 130;
export const APP_ID_XEN = 140;
export const APP_ID_AHV = 141;
export const APP_ID_BLOCK_LEVEL = 150;

export const ASSET_TYPE_PHYSICAL = 'physical';
export const ASSET_TYPE_VMWARE_VM = 'VMware:VM';
export const ASSET_TYPE_HYPER_V_VM = 'Hyper-V:VM';
export const ASSET_TYPE_VMWARE_HOST = 'VMware Host';
export const ASSET_TYPE_XEN = 'Xen';
export const ASSET_TYPE_NDMP = 'NDMP NAS';
export const ASSET_TYPE_AHV = 'AHV Host';
export const ASSET_TYPE_AHV_VM = 'AHV:VM';

export const ASSET_DISPLAY_FILTER_PHYSICAL = 'Physical';
export const ASSET_DISPLAY_FILTER_VIRTUAL = gettext('Virtual');
export const ASSET_DISPLAY_FILTER_ALL = 'All';

export const ALERT_HELP_LINKS = {
    0: '21803964',
    1: '21803964',
    2: '21803964',
    3: '21803964',
    4: '21898139',
    5: '26127905',
    6: '21898149',
    7: '25342025',
    8: '26201924',
    9: '21898159',
    10: '22391340',
    11: '22391350',
    12: '22217785',
    13: '21898199',
    14: '22391370',
    15: '22346465',
    16: '22501479',
    17: '21898139',
    18: '26374555',
    19: '28207810',
    101: '21927514',
    102: '21927504'
};

// lmc - added for UEB
export const ALERT_SEVERITY_NOTICE = 'notice';
global.ALERT_SEVERITY_NOTICE = ALERT_SEVERITY_NOTICE;
export const ALERT_SEVERITY_WARNING = 'warning';
global.ALERT_SEVERITY_WARNING = ALERT_SEVERITY_WARNING;
export const ALERT_SEVERITY_CRITICAL = 'critical';
global.ALERT_SEVERITY_CRITICAL = ALERT_SEVERITY_CRITICAL;
// mmb
export const ALERT_AT_RISK = 'at_risk';
global.ALERT_AT_RISK = ALERT_AT_RISK;

// lmc - storage warning percentage thresholds.
export const STORAGE_WARNING_THRESHOLD = 75;
export const STORAGE_CRITICAL_THRESHOLD = 95;

// lmc - added for UEB
export const API_DIR = '/api';

// mmb - added for link to forums
export const FEEDBACK_URL = 'https://unitrends-support.force.com/UnitrendsFree/s';

// jtg - added for NAS data-source assets
export const NAS_POSTFIX = '-NAS-RRC';

// asm - added for WIR modes
export const MODE_NEW = 'new';
export const MODE_HALTED = 'halted';
export const MODE_AUDIT = 'audit';
export const MODE_LIVE = 'live';
export const MODE_IDLE = 'idle'; // vmware replicas
export const MODE_RESTORE = 'restore'; // vmware replicas

// job type for vmware replicas is returned as vmware host
export const VMWARE_REPLICA_JOB_TYPE = 'VMware host';


// asm - added for WIR of coped asset
export const COPIED_ASSET = ' (copied asset)';

// asm - added for type of hypervisor
export const HYPERVISOR_UNITRENDS_APPLIANCE = 'Unitrends appliance';
export const HYPERVISOR_UNITRENDS_APPLIANCE_CAPITALIZED = 'Unitrends Appliance';
export const HYPERVISOR_VMWARE_HOST = 'VMware host';
export const HYPERVISOR_HYPERV_HOST = 'Hyper-V host';

// asm - Application Type Names
export const APPLICATION_TYPE_NAME_FILE_LEVEL = 'file-level';
export const APPLICATION_TYPE_NAME_BLOCK_LEVEL = 'image-level';
export const APPLICATION_TYPE_NAME_PHYSICAL_SERVER = 'Physical Server';
export const APPLICATION_TYPE_NAME_EXCHANGE = 'Exchange';
export const APPLICATION_TYPE_NAME_SQL_SERVER = 'SQL Server';
export const APPLICATION_TYPE_NAME_ARCHIVE = 'Archive';
export const APPLICATION_TYPE_NAME_VMWARE = 'VMware';
export const APPLICATION_TYPE_NAME_HYPER_V = 'Hyper-V';
export const APPLICATION_TYPE_NAME_SYSTEM_METADATA = 'System Metadata';
export const APPLICATION_TYPE_NAME_ORACLE = 'Oracle';
export const APPLICATION_TYPE_NAME_SHAREPOINT = 'SharePoint';
export const APPLICATION_TYPE_NAME_UCS_SERVICE_PROFILE = 'UCS Service Profile';
// Cisco UCS

export const APPLICATION_TYPE_NAME_VOLUME = 'Volume';
// NDMP

export const APPLICATION_TYPE_NAME_NDMP_DEVICE = 'NDMP Device';
// NDMP device needed for job display

export const APPLICATION_TYPE_NAME_XEN = 'Xen';
export const APPLICATION_TYPE_NAME_AHV = 'AHV';

export const BACKUP_METHOD_IMAGE_LEVEL = 'image-level';
export const BACKUP_METHOD_FILE_LEVEL = 'file-level';

export const APPLICATION_TYPE_DISPLAY_NAME_BLOCK_LEVEL = 'Image Level';
export const APPLICATION_TYPE_DISPLAY_NAME_FILE_LEVEL = 'File Level';
export const APPLICATION_TYPE_DISPLAY_NAME_NAS = 'NAS';

// Inventory ID - System Nodes
export const INVENTORY_ID_SYSTEM = 1001;
export const INVENTORY_ID_NAVGROUP = 1002;

// Inventory ID - Client Nodes
export const INVENTORY_ID_CLIENT_AIX = 2001;
export const INVENTORY_ID_CLIENT_DOS = 2002;
export const INVENTORY_ID_CLIENT_FREE_BSD = 2003;
export const INVENTORY_ID_CLIENT_HPUX = 2004;
export const INVENTORY_ID_CLIENT_I_SERIES = 2005;
export const INVENTORY_ID_CLIENT_LINUX = 2006;
export const INVENTORY_ID_CLIENT_MAC = 2007;
export const INVENTORY_ID_CLIENT_NETWARE = 2008;
export const INVENTORY_ID_CLIENT_OES = 2009;
export const INVENTORY_ID_CLIENT_OS2 = 2010;
export const INVENTORY_ID_CLIENT_SGI = 2011;
export const INVENTORY_ID_CLIENT_SCO = 2012;
export const INVENTORY_ID_CLIENT_SOLARIS = 2013;
export const INVENTORY_ID_CLIENT_UNIX = 2014;
export const INVENTORY_ID_CLIENT_WINDOWS = 2015;
export const INVENTORY_ID_CLIENT_OTHER = 2016;
global.INVENTORY_ID_CLIENT_OTHER = INVENTORY_ID_CLIENT_OTHER;

// Inventory ID - Cisco UCS Nodes
export const INVENTORY_ID_CISCO_UCS_CLIENT = 101001;
export const INVENTORY_ID_CISCO_UCS_SERVICE_PROFILE = 101002;

// Inventory ID - Exchange Nodes
export const INVENTORY_ID_EXCHANGE_APPLICATION = 102001;
export const INVENTORY_ID_EXCHANGE_DATABASE = 102002;

// Inventory ID - Hyper-V Nodes
export const INVENTORY_ID_HYPER_V_SERVER = 201002; // Application Node
export const INVENTORY_ID_HYPER_V_VM = 201003;
export const INVENTORY_ID_HYPER_V_WIR_VM = 201007;

// Inventory ID - Oracle Nodes
export const INVENTORY_ID_ORACLE_APPLICATION = 104001;
export const INVENTORY_ID_ORACLE_DATABASE = 104002;

// Inventory ID - SharePoint Nodes
export const INVENTORY_ID_SHAREPOINT_APPLICATION = 105001;
export const INVENTORY_ID_SHAREPOINT_FARM = 105002;

// Inventory ID - SQL Nodes
export const INVENTORY_ID_SQL_SERVER = 106003; // Application Node
export const INVENTORY_ID_SQL_DATABASE = 106004;
export const INVENTORY_ID_SQL_INSTANCE = 106006;

// Inventory ID - NDMP Nodes
export const INVENTORY_ID_NDMP_CLIENT = 103001;
export const INVENTORY_ID_NDMP_VOLUME = 103002;

// Inventory ID - VMware Nodes
export const INVENTORY_ID_VMWARE_CLUSTER = 202004;
global.INVENTORY_ID_VMWARE_CLUSTER = INVENTORY_ID_VMWARE_CLUSTER;
export const INVENTORY_ID_VMWARE_ESX_SERVER = 202005;
global.INVENTORY_ID_VMWARE_ESX_SERVER = INVENTORY_ID_VMWARE_ESX_SERVER;
export const INVENTORY_ID_VMWARE_FOLDER = 202006;
global.INVENTORY_ID_VMWARE_FOLDER = INVENTORY_ID_VMWARE_FOLDER;
export const INVENTORY_ID_VMWARE_RESOURCE_POOL = 202007;
global.INVENTORY_ID_VMWARE_RESOURCE_POOL = INVENTORY_ID_VMWARE_RESOURCE_POOL;
export const INVENTORY_ID_VMWARE_V_APP = 202008;
global.INVENTORY_ID_VMWARE_V_APP = INVENTORY_ID_VMWARE_V_APP;
export const INVENTORY_ID_VMWARE_VM = 202009;
global.INVENTORY_ID_VMWARE_VM = INVENTORY_ID_VMWARE_VM;
export const INVENTORY_ID_VMWARE_TEMPLATE = 202010;
global.INVENTORY_ID_VMWARE_TEMPLATE = INVENTORY_ID_VMWARE_TEMPLATE;
export const INVENTORY_ID_VMWARE_VM_DISK = 202011;
global.INVENTORY_ID_VMWARE_VM_DISK = INVENTORY_ID_VMWARE_VM_DISK;
export const INVENTORY_ID_VMWARE_WIR_VM = 202012;
global.INVENTORY_ID_VMWARE_WIR_VM = INVENTORY_ID_VMWARE_WIR_VM;

// XEN
export const INVENTORY_ID_XEN_POOL_MASTER = 203001;
export const INVENTORY_ID_XEN_STANDALONE_SERVER = 203002;
export const INVENTORY_ID_XEN_SERVER_IN_A_POOL = 203003;
export const INVENTORY_ID_XEN_VM = 203007;
export const INVENTORY_ID_XEN_VM_DISK = 203008;
export const INVENTORY_ID_XEN_CUSTOM_TEMPLATE = 203009;

// AHV
export const INVENTORY_ID_AHV_CLUSTER = 204001;
export const INVENTORY_ID_AHV_VM = 204002;
export const INVENTORY_ID_AHV_VM_DISK = 203003;

// Inventory ID - Block Nodes
export const INVENTORY_ID_BLOCK = 205001;

// Inventory Type Family
export const INVENTORY_TYPE_FAMILY_SYSTEM = 1000;
export const INVENTORY_TYPE_FAMILY_NAVGROUP = 1001;
export const INVENTORY_TYPE_FAMILY_CLIENT = 2000;
export const INVENTORY_TYPE_FAMILY_CISCO_UCS = 101000;
export const INVENTORY_TYPE_FAMILY_EXCHANGE = 102000;
export const INVENTORY_TYPE_FAMILY_NDMP = 103000;
export const INVENTORY_TYPE_FAMILY_HYPER_V = 201000;
export const INVENTORY_TYPE_FAMILY_ORACLE = 104000;
export const INVENTORY_TYPE_FAMILY_SHAREPOINT = 105000;
export const INVENTORY_TYPE_FAMILY_SQL = 106000;
export const INVENTORY_TYPE_FAMILY_VMWARE = 202000;
export const INVENTORY_TYPE_FAMILY_XEN = 203000;
export const INVENTORY_TYPE_FAMILY_AHV = 204000;
export const INVENTORY_TYPE_FAMILY_BLOCK = 205000;
export const INVENTORY_TYPE_FAMILY_CLIENT_NAS = 2100;// NAS is only handled in UI

// Quiesce Setting Display Name
export const QUIESCE_MULTIPLE_SETTINGS                           = gettext('multiple');
export const QUIESCE_SETTING_DISPLAY_NAME_APPLICATION_CONSISTENT = gettext('Application Consistent');
export const QUIESCE_SETTING_DISPLAY_NAME_APPLICATION_AWARE      = gettext('Application Aware');
export const QUIESCE_SETTING_DISPLAY_NAME_CRASH_CONSISTENT       = gettext('Crash Consistent');
export const QUIESCE_CURRENT_DEFAULT_MESSAGE_STRING_1_OF_2       = gettext('The default quiesce setting for this appliance is ');
export const QUIESCE_CURRENT_DEFAULT_MESSAGE_STRING_2_OF_2       = gettext('.  To edit this setting, please open the Manage Global VM Settings dialogue on the Protected Assets tab of the Configure page.');

// App Aware (VSS) Flag (Block Agent) app_aware_setting
export const APP_AWARE_SETTING_NOT_AWARE_OF_APPLICATIONS_VSS_FULL  = 2;  // Image Level Backups Quiesce; Exchange Backups Cannot Be Run
export const APP_AWARE_SETTING_AWARE_OF_APPLICATIONS_VSS_COPY      = 1;  // Exchange Backups Quiesce; Image Level Backups Do Not Quiesce

// User roles
export const SYSTEM_ROLE_DISPLAY_NAME_BACKUP_SYSTEM                  = 'Backup System';
export const SYSTEM_ROLE_DISPLAY_NAME_MANAGER                        = 'Manager';
export const SYSTEM_ROLE_DISPLAY_NAME_TARGET                         = 'Target';
export const SYSTEM_ROLE_DISPLAY_NAME_MANAGED_DPU                    = 'Managed DPU';
export const SYSTEM_ROLE_DISPLAY_NAME_DPU_CONFIGURED_FOR_VAULTING    = 'DPU Configured for Vaulting';
export const SYSTEM_ROLE_DISPLAY_NAME_REPLICATION_SOURCE             = 'Replication Source';
export const SYSTEM_ROLE_DISPLAY_NAME_NON_MANAGED_REPLICATION_SOURCE = 'Non-Managed Replication Source';
export const SYSTEM_ROLE_DISPLAY_NAME_PENDING_REPLICATION_SOURCE     = 'Pending Replication Source';

// Job Status
export const CANCELLED  = 'Cancelled';
export const IDLE       = 'Idle';
export const RUNNING    = 'Running';
export const WARNING    = 'Warning';
export const ACTIVE     = 'Active';
export const QUEUED     = 'Queued';
export const PAUSED     = 'Paused';
export const SUCCESSFUL = 'Successful';
export const ERROR      = 'Error';
export const CONNECTING = 'Connecting';

// Backup Catalog Load options
export const BACKUP_CATALOG_LOAD_BACKUPS = 1;
global.BACKUP_CATALOG_LOAD_BACKUPS = BACKUP_CATALOG_LOAD_BACKUPS;
export const BACKUP_CATALOG_LOAD_BACKUPS_COLD_COPIES = 2;
global.BACKUP_CATALOG_LOAD_BACKUPS_COLD_COPIES = BACKUP_CATALOG_LOAD_BACKUPS_COLD_COPIES;
export const BACKUP_CATALOG_LOAD_BACKUPS_COLD_HOT_COPIES = 4;
global.BACKUP_CATALOG_LOAD_BACKUPS_COLD_HOT_COPIES = BACKUP_CATALOG_LOAD_BACKUPS_COLD_HOT_COPIES;
export const BACKUP_CATALOG_LOAD_ALL = 7;
global.BACKUP_CATALOG_LOAD_ALL = BACKUP_CATALOG_LOAD_ALL;

// Common hostname error message used by the protected asset dialogs.
export const HOSTNAME_NON_WINDOWS_ERROR_MESSAGE = gettext("must be alphanumeric characters, '-', '_', or '.' and at most 31 characters");
export const HOSTNAME_ERROR_MESSAGE = `${HOSTNAME_NON_WINDOWS_ERROR_MESSAGE}, ${gettext('with at most 15 recommended if Windows.')}`;

export const TOUR_STEP_DASHBOARD_START = 1;
export const TOUR_STEP_DASHBOARD_END = 6;
export const TOUR_STEP_PROTECT_START = 7;
export const TOUR_STEP_PROTECT_END = 10;
export const TOUR_STEP_RECOVER_START = 11;
export const TOUR_STEP_RECOVER_END = 14;
export const TOUR_STEP_JOBS_START = 15;
export const TOUR_STEP_JOBS_END = 19;
export const TOUR_STEP_REPORTS_START = 20;
export const TOUR_STEP_REPORTS_END = 21;
export const TOUR_STEP_CONFIG_START = 22;
export const TOUR_STEP_CONFIG_END = 24;

/*
 * KB Help Links
 */
export const KB_URL = 'https://support.unitrends.com/go/';

export const DEFAULT_USER = 'root';
export const DEFAULT_PW = 'unitrends1';

/*
 * Session Timeout error
 */
export const SESSION_TIMEOUT_ERROR = gettext('Error: Your session has expired or is invalid.  Please log in again to continue.');
global.SESSION_TIMEOUT_ERROR = SESSION_TIMEOUT_ERROR;
// Generic message for unknown error/no response for REST API.
export const UNKNOWN_API_ERROR = 'A communications error occurred, and no response was received from the appliance.'
+ '<br/><br/>'
+ 'This may be caused by a problem with the appliance or the browser.  Ensure that the appliance is running '
+ 'and retry this operation.  You may also need to close and re-open the browser if the failure persists.';
global.UNKNOWN_API_ERROR = UNKNOWN_API_ERROR;

// Operating System Type (os type)
export const OS_DOS = 1;
export const OS_WIN_16 = 2;
export const OS_NT = 3;
export const OS_WINDOWS_95 = 4;
export const OS_OS_2 = 5;
export const OS_NOVELL = 6;
export const OS_UNIX3 = 7;
export const OS_ODT = 8;
export const OS_OS5 = 9;
export const OS_UNIX4 = 10;
export const OS_SOLARIS = 11;
export const OS_SUN_OS = 12;
export const OS_NOVELL_4 = 13;
export const OS_OSF1 = 14;
export const OS_NT_SERVER = 15;
export const OS_AIX = 16; // Not Applicable in our Environment
export const OS_SGI = 17;
export const OS_DGUX = 18;
export const OS_HP_UX = 19;
export const OS_LINUX = 20;
export const OS_BSDI = 21;
export const OS_USL = 22;
export const OS_UNIXWARE = 23;
export const OS_FREEBSD = 24;
export const OS_MACOS = 25;
export const OS_NOVELL_5 = 26; // The API Guide lists this as just Novell, but there is already one Novell, so I am guessing this is Novell 5
export const OS_NOVELL_6 = 27;
export const OS_NOVELL_65 = 28;
export const OS_WINDOWS_2000 = 29;
export const OS_WINDOWS_XP = 30;
export const OS_WINDOWS_2003 = 31;
export const OS_WINDOWS_VISTA = 32;
export const OS_IBMI5 = 33;
export const OS_OES = 34;
export const OS_WINDOWS_2008 = 35;
export const OS_WIN_2008_R2 = 36;
export const OS_WINDOWS_7 = 37;
export const OS_WINDOWS_8 = 38;
export const OS_WINDOWS_2012 = 39;
export const OS_GENERIC = 40;
export const OS_WINDOWS_8_1 = 41;
export const OS_WINDOWS_2012_R2 = 42;
export const OS_WINDOWS_10 = 43;
export const OS_WINDOWS_2016 = 44;
export const OS_WINDOWS_2019 = 45;

// Used when initializing an empty sid for backup catalog filters.
export const DUMMY_URL_SID = '&sid=-1';
global.DUMMY_URL_SID = DUMMY_URL_SID;
