<?php

header( 'Content-Type: text/javascript' );
header( 'Expires: -1' ); 
header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT' ); 
header( 'Cache-Control: no-store, no-cache' ); 
header( 'Cache-Control: post-check=0, pre-check=0', false ); 
header( 'Pragma: no-cache' ); 

//
// Is this a Unitrends Free or Google Edition?
//
bp_bypass_cookie(2);
$Capabilities = bp_get_capabilities(NULL);
if ($Capabilities !== -1) {
	$isCE = isset($Capabilities['CE']) && $Capabilities['CE'] ? 1 : 0;
	$isGoogle = isset($Capabilities['google']) && $Capabilities['google'] ? 1 : 0;
	$isVirtual = isset($Capabilities['virtual_machine']) && $Capabilities['virtual_machine'] ? 1 : 0;
    $isXen = isset($Capabilities['Xen']) && $Capabilities['Xen'] ? 1 : 0;
    $isKumo = isset($Capabilities['kumo']) && $Capabilities['kumo'] ? 1 : 0;
    $showArchiving = isset($Capabilities['no_archiving']) && $Capabilities['no_archiving'] ? 0 : 1;
    $showRetention = isset($Capabilities['global_retention']) && $Capabilities['global_retention'] ? 0 : 1;
    $showBlock = isset($Capabilities['block']) && $Capabilities['block'] ? 1 : 0;
} else {
	$isCE = 0;
	$isGoogle = 0;
	$isVirtual = 0;
    $isXen = 0;
    $isKumo = 0;
    $showArchiving = 1;
    $showRetention = 1;
    $showBlock = 0;
}

$licenseClass = "";
$license = bp_get_license_info();
if ($license !== false) {
    $licenseClass = $license['class'];
    $mktString = isset($license['mkt_name']) ? $license['mkt_name']: "";
    $featureString = isset($license['feature_string']) ? $license['feature_string'] : "";
}

$assetTag = "";
$asset = bp_get_asset_tag();
if ($asset !== false) {
    $assetTag = $asset;
}

$appVersion = shell_exec('rpm -q --queryformat "%{version}-%{release}" unitrends-ui 2>&1');
if ($appVersion === NULL) {
    $appVersion = "10.1.0";
}

//
// If the portal server package is installed, show Networked/Loosely Coupled functionality
//
system('rpm -q --quiet xg-portal-server', $portalReturnValue);
$showLooselyCoupled = $portalReturnValue === 0 ? 1 : 0;

$localID = 1;
$local = bp_get_local_system_id();
if ($local !== false) {
    $localID = $local;
}
$localName = "local";
$local = bp_get_system_info($localID);
if ($local !== false && isset($local['name'])) {
    $localName = $local['name'];
}

$licenseType = bp_run_command("Appliance", "", NULL);

$isTarget = 0;
$identity = 'DPU';
$nvpConfig = bp_get_nvp_list("RRC", "configuration");
if ($nvpConfig !== false && isset($nvpConfig['Identity'])) {
    $identity = $nvpConfig['Identity'];
    if ($identity === 'DPV' || $identity === 'DPXV') {
        $isTarget = 1;
    }
}

// Global Preferences for setup wizard.  These are on a per-user basis, so we look to root's preferences.
$showWizard = -1;
$showEULA = -1;
$defaultLanguage = "en";
$preferences = rest_get_preferences('root');
if ($preferences !== false) {
    $showWizard = isset($preferences['show_setup_wizard']) ? $preferences['show_setup_wizard'] : -1;
    $showEULA = isset($preferences['show_eula']) ? $preferences['show_eula'] : -1;
    $showTour = isset($preferences['show_help_overlay']) ? $preferences['show_help_overlay'] : -1;
    isset($preferences['language']) ? $defaultLanguage = $preferences['language'] : false;
}

// Satori needs to *not* force the setup wizard on an upgrade where the user has already set up through the RRC.
$nvp = bp_get_nvp_list("preferences", "root");
if ($nvp !== false && isset($nvp['SetupWizardPopup']) && $nvp['SetupWizardPopup'] === "false") {
    $showWizard = $nvp['SetupWizardPopup'];
    $showEULA = $nvp['SetupWizardPopup'];
}

//Need to check if current version of Satori supports RDR.
$rdr = bp_rdr_supported($localID);
if ($rdr !== null) {
    $rdrSupported = $rdr ? 1 : 0;
} else {
    $rdrSupported = 0;
}

//check to see if one to many is supported
$oneToManySupported = function_exists('bp_one_to_many_supported') ? bp_one_to_many_supported($localID) : -1;


$vmReplicas = function_exists('bp_replica_vms_supported') ? bp_replica_vms_supported($localID) : -1;

$hypervReplicasSupported = 0;
$vmWareReplicasSupported = 0;

if ($vmReplicas !== -1 && is_array($vmReplicas)){
    foreach ($vmReplicas as $id => $hypervisor){
        if ($hypervisor == 'Hyper-V host'){
            $hypervReplicasSupported = 1;
        }
        if ($hypervisor == 'VMware host'){
            $vmWareReplicasSupported = 1;
         }
    }
}

// for new simple gateway platform, always show SLA Policies.
if ($isKumo) {
    $showSLAPolicies = 1;
} else {
    $showSLAPolicies = bp_get_ini_value("CMC", "showSLAPolicies");
    if ($showSLAPolicies !== false) {
        $showSLAPolicies = (strtolower($showSLAPolicies) == 'true') ? 1 : 0;
    } else {
        $showSLAPolicies = 0;
    }
}

// AHV
$showAHV = 1; // NO LONGER USED: bp_get_ini_value("CMC", "showAHV");

//get maximum vm replica recovery point
$maxRecoveryPoints = 0;
$maxReplicaSnapshots = function_exists('bp_get_max_replica_snapshots') ? bp_get_max_replica_snapshots() : false;
if ( $maxReplicaSnapshots !== false ) {
    $maxRecoveryPoints = $maxReplicaSnapshots['VMware host'];
}

bp_destroy_cookie();
?>


var localID = <?php echo $localID ?>;
var localName = <?php echo '"'.$localName. '"' ?>;

var maxRecoveryPoints = <?php echo $maxRecoveryPoints ?>;
//ga('create', 'UA-59340304-5', gaObj);

var isCE = <?php echo $isCE ?>;
var isGoogle = <?php echo $isGoogle ?>;
var isVirtual = <?php echo $isVirtual ?>;
var isXenUEB = <?php echo $isXen ?>;
var isTarget = <?php echo $isTarget ?>;
var isKumo = <?php echo $isKumo ?>;
var appName = isCE ? (isGoogle ? "Unitrends Free Google" : "Unitrends Free") : (isVirtual ? "UEB" : "RecoverySeries");
var trackingCode = isCE ? (isGoogle ? "UA-66229629-2" : "UA-66229629-1") : (isVirtual ? "UA-66229629-3" : "UA-66229629-4");
var appVersion = <?php echo '"'.$appVersion. '"' ?>;
var identity = <?php echo '"'.$identity. '"' ?>;
var featureString = <?php echo '"'.$featureString. '"' ?>;
var showWizard = <?php echo $showWizard ?>;
var showEULA = <?php echo $showEULA ?>;
var showTour = <?php echo $showTour ?>;
var showLooselyCoupled = <?php echo $showLooselyCoupled ?>;
var rdrSupported = <?php echo $rdrSupported ?>;
var showSLAPolicies = <?php echo $showSLAPolicies ?>;
var showAHV = <?php echo $showAHV ?>;
var showArchiving = <?php echo $showArchiving ?>;
var showRetention = <?php echo $showRetention ?>;
var defaultLanguage = <?php echo '"'.$defaultLanguage. '"' ?>;
var vmWareReplicasSupported = <?php echo $vmWareReplicasSupported ?>;
var hypervReplicasSupported = <?php echo $hypervReplicasSupported ?>;
var showBlock = <?php echo $showBlock ?>;
var oneToManySupported = <?php echo $oneToManySupported ?>;

var gaCode = <?php echo '"'.$assetTag. '"' ?>;
var gaObj = "auto";
if (gaCode !== "") {
gaObj = { 'userId': gaCode };
}
ga('create', trackingCode, gaObj);
ga('set', {
'appName': appName,
'appVersion': appVersion
});

var refreshRates = {};
var DEFAULT_REFRESH = 5000;
refreshRates.dash_backup_refresh = DEFAULT_REFRESH;
refreshRates.dash_replication_refresh = DEFAULT_REFRESH;
refreshRates.dash_restore_refresh = DEFAULT_REFRESH;
refreshRates.dash_active_job_refresh = DEFAULT_REFRESH;
refreshRates.dash_alert_refresh = DEFAULT_REFRESH;
refreshRates.dash_storage_refresh = DEFAULT_REFRESH;
refreshRates.page_protect_refresh = DEFAULT_REFRESH;
refreshRates.page_restore_refresh = DEFAULT_REFRESH;
refreshRates.page_jobs_refresh = DEFAULT_REFRESH;
refreshRates.dash_forum_posts_refresh = DEFAULT_REFRESH;
refreshRates.dash_daily_feed_refresh = DEFAULT_REFRESH;
refreshRates.dash_recovery_assurance_refresh = DEFAULT_REFRESH;

var global_user = {};
var licenseClass = <?php echo '"'.$licenseClass. '"' ?>;
var assetTag = <?php echo '"'.$assetTag. '"' ?>;
var licenseType = <?php echo '"'.$licenseType. '"' ?>;
var mktString = <?php echo '"'.$mktString.'"' ?>;
