(function($, PHD, window, undefined) {

    var EmailTable = function EmailTable($form) {
        if(this instanceof EmailTable) {
            this.$form = $form;
            this.$table = this.$form.find("#email-reporting-table");
            this.$tbody = this.$table.children("tbody");
            this.rowHTML = $("#email-row-template").html();
            this.regex = /__prefix__/gi;

            this.$addButton = this.$table.find(".btn-add-recipient");

            // Access the gettextCatalog service injected into the app.
            var elem = angular.element(document.querySelector('[ng-controller=GlobalCtrl]'));
            var injector = elem.injector();
            var gettextCatalog = injector.get('gettextCatalog');
            if (!_.isObject(gettextCatalog)) {
                gettextCatalog = { 'getString': function(item) { return item } };
            }
            this.removeBut = '<span class="btn-remove-recipient"><i class="icon-removesign" title="' +
                                gettextCatalog.getString('Remove Recipient') + '"></i></span>';

            //this.$management = $("#email-reporting-management");
            //this.$emailCounter = this.$management.find("[id$=TOTAL_FORMS]");
            this.emailRows = 1;//this.$emailCounter.val();

            this.$container = this.$table.parent();
        } else {
            return new EmailTable($form).init();
        }
    }

    EmailTable.prototype = {
        init: function() {
            var self = this;

            this.$table
                .on("click", ".btn-add-recipient", function() {self.addRow()})
                .on("click", ".btn-remove-recipient", function() {self.removeRow($(this).closest("tr"))})
                .on("keydown", "input.email", function(event) {
                    event.stopPropagation();
                    if(event.keyCode == $.ui.keyCode.ENTER) {
                        self.addRow();
                    }
                })
                .find(".ctrl-delete input[type=checkbox]")
                    .hide()
                    .before(this.removeBut);

            this.$form.find(".ctrl-email input").addClass("email");

            return this;
        },

        validateEmails: function() {
            this.$form.find(".ctrl-email input").addClass("required");
            var valid = this.$form.validate().subset(this.$tbody);
            this.$form.find(".ctrl-email input").removeClass("required");
            return valid;
        },

        addRow: function() {
            if(this.validateEmails()) {
                var $newRow = $("<tr>"),
                    rowHTML = this.rowHTML.replace(this.regex, this.emailRows);

                $newRow.html(rowHTML).appendTo(this.$tbody);
                this.$addButton.detach().prependTo($newRow.find(".ctrl-add"));
                $newRow.find(".ctrl-delete input[type=checkbox]")
                    .hide()
                    .before(this.removeBut);

                this.emailRows++;
                //this.$emailCounter.val(this.emailRows);
                this.$form.find(".ctrl-email input").addClass("email");
                $newRow.find("[type=text]").focus();
                this.$container.scrollTop(this.$container.prop("scrollHeight"));
            }
            this.$table.trigger("emailtableadd");
        },

        removeRow: function($row) {
            var $add = $row.find(".btn-add-recipient").length > 0 ? $row.find(".btn-add-recipient") : null,
                $check = $row.find(".ctrl-delete input[type=checkbox]"),
                $rows = this.$tbody.find("tr:visible");

            if($rows.length == 1) {
                $row.find("input.email").val("");
                return false;
            }

            $row.addClass("hidden").find(".ctrl-delete input[type=checkbox]").prop("checked", true);
            $row.find("input.email").val("");

            if($add !== null) {
                $add.detach().prependTo(this.$tbody.find("tr:visible").last().find(".ctrl-add"));
            }
            this.$table.trigger("emailtabledelete");
            $('.setwidthemail').css({"width":"55px","text-align":"center", "min-width":"55px", "max-width":"55px"});
        }
       
        
    };

    PHD.EmailTable = EmailTable;

})(jQuery, window.PHD || (window.PHD = {}), window);