(function($, PHD, window, undefined) {
    
    /*
    *   Exports an object that converts integer constants to class names
    */

    var lookup = {
        get: function(key, num, prefix) {
            if(num === false || num === true) {
                num = num === false ? 0 : 1;
            }
            var state;
		    // lmc add prefix
	        if (prefix != null) {
                state = this.hasOwnProperty(prefix + key) ? this[prefix + key][num] :
                        this.hasOwnProperty(key) ? this[key][num] : "";
	        } else {
                state = this.hasOwnProperty(key) ? this[key][num] : "";
            }
            return state;
        }
    };

    lookup.alert_type = {};
    lookup.alert_type[ALERT_TYPE_UNKNOWN] = "alert-type-unknown";
    lookup.alert_type[ALERT_TYPE_OTHER] = "alert-type-other";
    lookup.alert_type[ALERT_TYPE_LICENSE_EXPIRED] = "alert-type-license-expired";
    lookup.alert_type[ALERT_TYPE_LICENSE_INVALID] = "alert-type-license-invalid";
    lookup.alert_type[ALERT_TYPE_UPDATES_AVAILABLE] = "alert-type-updates-available";
    lookup.alert_type[ALERT_TYPE_BDS_CONNECTIVITY] = "alert-type-bds-connectivity";
    lookup.alert_type[ALERT_TYPE_BDS_LOW_SPACE] = "alert-type-bds-low-space";
    lookup.alert_type[ALERT_TYPE_VBA_CONNECTIVITY] = "alert-type-vba-connectivity";
    lookup.alert_type[ALERT_TYPE_BACKUP_WINDOW] = "alert-type-backup-window";
    lookup.alert_type[ALERT_TYPE_BACKUP_NO_CBT] = "alert-type-backup-no-cbt";
    lookup.alert_type[ALERT_TYPE_BACKUP_FULL] = "alert-type-backup-full";
    lookup.alert_type[ALERT_TYPE_HYPERVISOR_SNAPSHOT] = "alert-type-hypervisor-snapshot";
    lookup.alert_type[ALERT_TYPE_HYPERVISOR_LOGIN] = "alert-type-hypervisor-login";
    lookup.alert_type[ALERT_TYPE_UNPROTECTED_VM] = "alert-type-unprotected-vm";
    lookup.alert_type[ALERT_TYPE_FLR] = "alert-type-flr";
    lookup.alert_type[ALERT_TYPE_INVENTORY_SYNC] = "alert-type-inventory-sync";
    lookup.alert_type[ALERT_TYPE_UPDATE_COMPLETE] = "alert-type-update-complete";
    lookup.alert_type[ALERT_TYPE_EMAIL_ERROR] = "alert-type-email-error";
    lookup.alert_type[ALERT_TYPE_SMTP_NOT_CONFIGURED] = "alert-type-smtp-not-configured";

    /* lmc */
    lookup.severity = {};
    lookup.severity[ALERT_SEVERITY_NOTICE] = "severity-notice";
    lookup.severity[ALERT_SEVERITY_WARNING] = "severity-warning";
    lookup.severity[ALERT_SEVERITY_CRITICAL] = "severity-critical";
    //mmb
    lookup.severity[ALERT_AT_RISK] = "severity-at-risk";

    lookup.backup_mode = {};
    lookup.backup_mode[BACKUP_MODE_VIRTUAL_FULL] = "backup-mode-virtual-full";
    lookup.backup_mode[BACKUP_MODE_FULL_AND_INC] = "backup-mode-full-and-inc";

    lookup.bds_type = {};
    lookup.bds_type[BDS_TYPE_BACKUP] = "bds-type-backup";
    lookup.bds_type[BDS_TYPE_REPLICATION] = "bds-type-replication";
    lookup.bds_type[BDS_TYPE_CLOUD_CACHE] = "bds-type-cloud-cache";
    lookup.bds_type[BDS_TYPE_IR_CACHE] = "bds-type-ir-cache";
    lookup.bds_type[BDS_TYPE_ARCHIVE] = "bds-type-archive";
    lookup.bds_type[BDS_TYPE_SYNC] = "bds-type-sync";

    lookup.connection_status = {};
    lookup.connection_status[CONN_STATUS_ON] = 'connection-status-powered-on';
    lookup.connection_status[CONN_STATUS_OFF] = 'connection-status-powered-off';
    lookup.connection_status[CONN_STATUS_CANNOT_CONNECT] = 'connection-status-cannot-connect';
    lookup.connection_status[CONN_STATUS_UNKNOWN] = 'connection-status-unknown';

    lookup.enabled = {};
    lookup.enabled[FALSE] = "enabled-false";
    lookup.enabled[TRUE] =  "enabled-true";

    lookup.job_enabled = {};
    lookup.job_enabled[FALSE] = "job-enabled-false";
    lookup.job_enabled[TRUE] =  "job-enabled-true";

    lookup.instant_state = {};
    lookup.instant_state[INSTANT_VM_STATE_UNKNOWN] = 'instant-state-unknown';
    lookup.instant_state[INSTANT_VM_STATE_CREATING] = 'instant-state-creating';
    lookup.instant_state[INSTANT_VM_STATE_ACTIVE] = 'instant-state-active';
    lookup.instant_state[INSTANT_VM_STATE_ENDING] = 'instant-state-ending';
    lookup.instant_state[INSTANT_VM_STATE_ENDED] = 'instant-state-ended';
    lookup.instant_state[INSTANT_VM_STATE_ERROR] = 'instant-state-error';
    lookup.instant_state[INSTANT_VM_STATE_SEEDING] = 'instant-state-seeding';
    lookup.instant_state[INSTANT_VM_STATE_READY] = 'instant-state-ready';
    lookup.instant_state[INSTANT_VM_STATE_COMPLETING] = 'instant-state-completing';
    lookup.instant_state[INSTANT_VM_STATE_COMPLETED] = 'instant-state-completed';

    lookup.inventory_type = {};
    lookup.inventory_type[INVENTORY_ID_VMWARE_VM_DISK] = 'inventory-type-drive';
    lookup.inventory_type[INVENTORY_ID_VMWARE_VM] = 'inventory-type-vm';
    lookup.inventory_type[INVENTORY_ID_VMWARE_FOLDER] = 'inventory-type-folder';
    lookup.inventory_type[INVENTORY_ID_VMWARE_RESOURCE_POOL] = 'inventory-type-resource-pool';
    lookup.inventory_type[INVENTORY_ID_VMWARE_ESX_SERVER] = 'inventory-type-host';
    lookup.inventory_type[INV_TYPE_UNIVERSE] = 'inventory-type-universe';
    lookup.inventory_type[INVENTORY_ID_VMWARE_CLUSTER] = 'inventory-type-cluster';
    lookup.inventory_type[INVENTORY_ID_VMWARE_TEMPLATE] = 'inventory-type-template';
    lookup.inventory_type[INVENTORY_ID_VMWARE_V_APP] = 'inventory-type-vapp';
    lookup.inventory_type[INVENTORY_ID_CLIENT_OTHER] = 'inventory-type-compute-resource';

    lookup.is_management = {};
    lookup.is_management[0] = 'is-management-no';
    lookup.is_management[1] = 'is-management-yes';
    lookup.is_engine = {};
    lookup.is_engine[0] = 'is-engine-no';
    lookup.is_engine[1] = 'is-engine-yes';
    lookup.is_presentation = {};
    lookup.is_presentation[0] = 'is-presentation-no';
    lookup.is_presentation[1] = 'is-presentation-yes';

    lookup.job_state = {};

    lookup.job_status = {};
    /* lmc translate based on status */
    lookup.job_status['Paused'] = "job-status-paused";
    lookup.job_status["Queued"] = "job-status-queued";
    lookup.job_status["Connecting"] = "job-status-running";
    lookup.job_status["Active"] = "job-status-running";
    lookup.job_status["DB Update"] = "job-status-running";
    lookup.job_status["Cancelled"] = "job-status-canceled job-status-error";
    lookup.job_status["Warning"] = "job-status-finished job-status-partial-success";
    lookup.job_status["Successful"] = lookup.job_status["Success"] = "job-status-finished job-status-success";
    lookup.job_status['error'] = "job-status-finished job-status-error";
    lookup.job_status["Error"] = "job-status-finished job-status-error";
    lookup.job_status["Complete"] = "job-status-finished";
    lookup.job_status["Process Terminated"] = "job-status-finished job-status-error";
    lookup.job_status["Unknown"] = "job-status-unknown";
    lookup.job_status["Unknown/Cancelled"] = "job-status-finished";
    lookup.job_status["available"] = "job-status-finished job-status-success";
    lookup.job_status["Available"] = "job-status-finished job-status-success";

    lookup.job_type = {};
    lookup.job_type[JOB_TYPE_UNKNOWN] = "job-type-unknown";
    lookup.job_type[JOB_TYPE_BACKUP] = "job-type-backup";
    lookup.job_type[JOB_TYPE_RESTORE] = "job-type-restore";
    lookup.job_type[JOB_TYPE_ROLLBACK] = "job-type-rollback";
    lookup.job_type[JOB_TYPE_REPLICATION] = "job-type-replication";
    lookup.job_type[JOB_TYPE_NCDP] = "job-type-ncdp";
    lookup.job_type[JOB_TYPE_INSTANT_RESTORE] = "job-type-instant-restore";
    lookup.job_type[JOB_TYPE_LINK] = "job-type-link";
    lookup.job_type[JOB_TYPE_DELETE] = "job-type-delete";
    lookup.job_type[JOB_TYPE_BDSIO] = "job-type-bdsio";
    lookup.job_type[JOB_TYPE_VERIFY] = "job-type-verify";
    lookup.job_type[JOB_TYPE_ORPHAN_HUNT] = "job-type-orphan-hunt";
    lookup.job_type[JOB_TYPE_SNAPSHOT_HUNT] = "job-type-snapshot-hunt";
    lookup.job_type[JOB_TYPE_HYPERVISOR] = "job-type-hypervisor";
    lookup.job_type[JOB_TYPE_BACKUP_DISK] = "job-type-backup-disk";
    lookup.job_type[JOB_TYPE_RESTORE_DISK] = "job-type-restore-disk";
    lookup.job_type[JOB_TYPE_ARCHIVE] = "job-type-archive";
    lookup.job_type[JOB_TYPE_ARCHIVE_DISK] = "job-type-archive-disk";
    lookup.job_type[JOB_TYPE_IR_START] = "job-type-ir-start";
    lookup.job_type[JOB_TYPE_IR_SEED] = "job-type-ir-seed";
    lookup.job_type[JOB_TYPE_IR_MOTION] = "job-type-ir-motion";
    lookup.job_type[JOB_TYPE_IR_END] = "job-type-ir-end";
    /* lmc TODO */
    lookup.job_type["backup"] = "job-type-backup";
    lookup.job_type["certification"] = "job-type-certification";
    lookup.job_type["restore"] = "job-type-restore";
    lookup.job_type["replication"] = "job-type-replication";
    lookup.job_type["archive"] = "job-type-archive";
    lookup.job_type["instant recovery"] = "job-type-restore";

    lookup.log_level = {};
    lookup.log_level[LOG_LEVEL_EMERGENCY] = 'log-level-emergency';
    lookup.log_level[LOG_LEVEL_ALERT] = 'log-level-alert';
    lookup.log_level[LOG_LEVEL_CRITICAL] = 'log-level-critical';
    lookup.log_level[LOG_LEVEL_ERROR] = 'log-level-error';
    lookup.log_level[LOG_LEVEL_WARNING] = 'log-level-warning';
    lookup.log_level[LOG_LEVEL_NOTICE] = 'log-level-notice';
    lookup.log_level[LOG_LEVEL_INFO] = 'log-level-info';

    lookup.recovery_type = {};
    lookup.recovery_type[RECOVERY_JOB_TYPE_ROLLBACK] = "recovery-job-type-rollback";
    lookup.recovery_type[RECOVERY_JOB_TYPE_STANDARD] = "recovery-job-type-standard";
    lookup.recovery_type[RECOVERY_JOB_TYPE_INSTANT] = "recovery-job-type-instant";

    lookup.schedule_type = {};
    lookup.schedule_type[SCHEDULE_TYPE_NOW] = "schedule-type-now";
    lookup.schedule_type[SCHEDULE_TYPE_SCHEDULED] = "schedule-type-scheduled";

    lookup.system = {};
    lookup.system[FALSE] = "system-false";
    lookup.system[TRUE] = "system-true";

    lookup.version_info = {};
    lookup.version_info[VERSION_UP_TO_DATE] = "version-up-to-date";
    lookup.version_info[VERSION_NOT_UP_TO_DATE] = "version-not-up-to-date";
    lookup.version_info[VERSION_UPDATE_IN_PROGRESS] = "version-update-in-progress";

    PHD.StateLookup = lookup;

})(jQuery, window.PHD || (window.PHD = {}), window);
